# Practical Toolbox

## Download Tools

- [Sci-Hub](https://sci-hub.se/): A revolutionary site aiming to break knowledge barriers, greeted by the goddess Elbakyan.
- [Library Genesis](http://libgen.is/): A website for downloading e-books.
- [Z-library](https://zlibrary-global.se/): An e-book download site (works better under [Tor](https://www.torproject.org/), [link](http://loginzlib2vrak5zzpcocc3ouizykn6k5qecgj2tzlnab5wcbqhembyd.onion/)).
- [Z-ePub](https://z-epub.com/): ePub e-book download site.
- [PDF Drive](https://www.pdfdrive.com/): A PDF e-book search engine.
- [MagazineLib](https://magazinelib.com/): A site for downloading PDF e-magazines.
- [BitDownloader](https://bitdownloader.io/): YouTube video downloader.
- [qBittorrent](https://www.qbittorrent.org/download.php): A BitTorrent client.
- [uTorrent](https://www.utorrent.com): Another BitTorrent client.
- [National Standard Information Public Service Platform](https://std.samr.gov.cn/): Official platform for querying and downloading various standards.
- [Standard Knowledge Service System](http://www.standards.com.cn/): Search and read the standards you need.
- [MSDN, I Tell You](https://msdn.itellyou.cn/): A site for downloading Windows OS images and other software.

## Design Tools

- [excalidraw](https://excalidraw.com/): A hand-drawn style drawing tool, great for creating diagrams in course reports or PPTs.
- [tldraw](https://www.tldraw.com/): A drawing tool suitable for flowcharts, architecture diagrams, etc.
- [draw.io](https://app.diagrams.net/): A powerful and concise online drawing website, supports flowcharts, UML diagrams, architecture diagrams, prototypes, etc., with export options for Onedrive, Google Drive, Github, and offline client availability.
- [origamiway](https://www.origamiway.com/paper-folding-crafts-step-by-step.shtml): Step-by-step origami tutorials.
- [thingiverse](https://www.thingiverse.com/): Includes various 2D/3D design resources, with STL files ready for 3D printing.
- [iconfont](https://www.iconfont.cn/): The largest icon and illustration library in China, useful for development or drawing system architecture diagrams.
- [turbosquid](https://www.turbosquid.com/): A platform to purchase various models.
- [flaticon](https://www.flaticon.com/): A site to download free and high-quality icons.
- [Standard Map Service System](http://bzdt.ch.mnr.gov.cn/): Official standard map downloads.
- [PlantUML](https://plantuml.com/zh/): Quickly write UML diagrams using code.

## Programming Related

- [sqlfiddle](http://www.sqlfiddle.com/): An easy-to-use online SQL Playground.
- [sqlzoo](https://sqlzoo.net/wiki/SQL_Tutorial): Practice SQL statements online.
- [godbolt](https://godbolt.org/): A convenient compiler exploration tool. Write some C/C++ code, choose a compiler, and observe the specific assembly code generated.
- [explainshell](https://explainshell.com/): Struggling with the meaning of a shell command? Try this site!
- [regex101](https://regex101.com/): A regex debugging site supporting various programming language standards.
- [typingtom](https://www.typingtom.com/lessons): Typing practice/speed test site for programmers.
- [wrk](https://github.com/wg/wrk): Website stress testing tool.
- [gbmb](https://www.gbmb.org/): Data unit conversion tool.
- [tools](https://tools.fun/): A collection of online tools.
- [github1s](https://github1s.com/): Read GitHub code online with a web-based VS Code.
- [visualgo](https://visualgo.net/en): Algorithm visualization website.
- [DataStructureVisual](http://www.rmboot.com/): Data structure visualization website.
- [Data Structure Visualizations](https://www.cs.usfca.edu/~galles/visualization/Algorithms.html): Visualization website for data structures and algorithms.
- [learngitbranching](https://learngitbranching.js.org/?locale=zh_CN): Visualize learning git.
- [UnicodeCharacter](https://unicode-table.com/en/): Unicode character set website.
- [cyrilex](https://extendsclass.com/regex-tester.html): A site for testing and visualizing regular expressions, supporting various programming language standards.
- [mockium](https://softwium.com/mockium/): Platform for generating test data.

## Learning Websites

- [HFS](https://hepsoftwarefoundation.org/training/curriculum.html): Various software tutorials.
- [Shadertoy](https://www.shadertoy.com/): Write various shaders.
- [comments-for-awesome-courses](https://conanhujinming.github.io/comments-for-awesome-courses/): Reviews of open courses from prestigious universities.
- [codetop](https://codetop.cc/home): Corporate problem bank.
- [cs-video-courses](https://github.com/Developer-Y/cs-video-courses): List of computer science courses with video lectures.
- [bootlin](https://elixir.bootlin.com/linux/v2.6.39.4/source/include/linux): Read Linux source code online.
- [ecust-CourseShare](https://github.com/tianyilt/ecnu-PGCourseShare): East China Normal University graduate course strategy sharing project.
- [REKCARC-TSC-UHT](https://github.com/PKUanonym/REKCARC-TSC-UHT): Tsinghua University computer science course strategy.
- [seu-master](https://github.com/oneman233/seu-master): Southeast University graduate course materials.
- [Runoob](https://www.runoob.com/): Brief tutorials on computer-related knowledge.
- [FreeBSD From Entry to Run Away](https://book.bsdcn.org/): A Chinese tutorial on FreeBSD.
- [MDN Web Docs](https://developer.mozilla.org/zh-CN/docs/Learn): MDN's beginner's guide to web development.
- [Hello Algorithm](https://www.hello-algo.com/): A quick introductory tutorial on data structures and algorithms with animations, runnable examples, and Q&A.

## Encyclopedic/Dictionarial Websites

- [os-wiki](https://wiki.osdev.org/Main_Page): An encyclopedia of operating system technology resources.
- [FreeBSD Documentation](https://docs.freebsd.org/en/): Official FreeBSD documentation.
- [Python3 Documentation](https://docs.python.org/zh-cn/3/): Official Chinese documentation for Python3.
- [C++ Reference](https://en.cppreference.com/w/): C++ reference manual.
- [OI Wiki](https://oi-wiki.org/): An integrated site for programming competition knowledge.
- [Microsoft Learn](https://learn.microsoft.com/zh-cn/): Microsoft's official learning platform, containing most Microsoft product documentation.
- [Arch Wiki](https://wiki.archlinux.org/): Wiki written for Arch Linux, containing a lot of Linux-related knowledge.
- [Qt Wiki](https://wiki.qt.io/Main): Official Qt Wiki.
- [OpenCV Chinese Documentation](https://opencv.apachecn.org/#/): Community version of OpenCV's Chinese documentation.
- [npm Docs](https://docs.npmjs.com/): Official npm documentation.

## Communication Platforms

- [GitHub](https://github.com/): Many open-source projects' hosting platform, also a major communication platform for many open-source projects, where issues can solve many problems.
- [StackExchange](https://stackexchange.com/): A programming community composed of 181 Q&A communities (including Stack Overflow).
- [StackOverflow](https://stackoverflow.com/): An IT technical Q&A site related to programming.
- [Gitee](https://gitee.com/): A code hosting platform similar to GitHub, where you can find solutions to common questions in the issues of corresponding projects.
- [Zhihu](https://www.zhihu.com/): A Q&A community similar to Quora, where you can ask questions, with some answers containing computer knowledge.
- [Cnblogs](https://www.cnblogs.com/): A knowledge-sharing community for developers, containing blogs on common questions. Accuracy is not guaranteed, please use with caution.
- [CSDN](https://blog.csdn.net/): Contains blogs on common questions. Accuracy is not guaranteed, please use with caution.

## Miscellaneous

- [tophub](https://tophub.today/): A collection of trending news headlines (aggregating from Zhihu, Weibo, Baidu, WeChat, etc.).
- [feedly](https://feedly.com/): A famous RSS feed reader.
- [speedtest](https://www.speedtest.net/zh-Hans): An online network speed testing website.
- [public-apis](https://github.com/public-apis/public-apis): A collective list of free APIs for development.
- [numberempire](https://zh.numberempire.com/derivativecalculator.php): A tool for calculating derivatives of functions.
- [sustech-application](https://sustech-application.com/#/grad-application/computer-science-and-engineering/README): Southern University of Science and Technology experience sharing website.
- [vim-adventures](https://vim-adventures.com/): An online game based on vim keyboard shortcuts.
- [vimsnake](https://vimsnake.com/): Play the snake game using vim commands.
- [keybr](https://www.keybr.com/): A website for learning touch typing.
- [Awesome C++](https://cpp.libhunt.com/): A curated list of awesome C/C++ frameworks, libraries, resources.
- [HelloGitHub](https://hellogithub.com/): Shares interesting and beginner-friendly open-source projects on GitHub.
- [Synergy](https://github.com/DEAKSoftware/Synergy-Binaries): A set of keyboard and mouse controls for multiple computers
