# CMU 15-799: Special Topics in Database Systems

## Course Introduction

- **University**: Carnegie Mellon University (CMU)
- **Prerequisites**: CMU 15-445
- **Programming Language**: C++
- **Course Difficulty**: 🌟🌟🌟
- **Estimated Study Time**: 80 hours

This course has only been offered twice so far, in Fall 2013 and Spring 2022, and it discusses some cutting-edge topics in the field of databases. The Fall 2013 session covered topics like Streaming, Graph DB, NVM, etc., while the Spring 2022 session mainly focused on Self-Driving DBMS, with relevant papers provided.

The tasks for the Spring 2022 version of the course included:

1. **Task One**: Manual performance tuning based on `PostgreSQL`.
2. **Task Two**: Improving the Self-Driving DBMS based on [NoisePage Pilot](https://github.com/cmu-db/noisepage-pilot), with no limitations on features.

The teaching style is more akin to a seminar, with fewer programming assignments. This course can broaden the horizons for general students and may be particularly beneficial for those specializing in databases.

## Course Resources

- **Course Homepages**:
  - [CMU15-799 - Special Topics in Database Systems (Fall 2013)](https://15799.courses.cs.cmu.edu/fall2013)
  - [CMU15-799 - Special Topics: Self-Driving Database Management Systems (Spring 2022)](https://15799.courses.cs.cmu.edu/spring2022/)

- **Course Videos**: Not available

- **Course Assignments**: 2 Projects + 1 Group Project