# Machine Learning Compilation

## Course Overview

- University: Online course
- Prerequisites: Foundations in Machine Learning/Deep Learning
- Programming Language: Python
--Difficulty: 🌟🌟🌟
- Estimated Hours: 30 hours

This course, offered by top scholar Chen Tianqi during the summer of 2022, focuses on the field of machine learning compilation. As of now, this area remains cutting-edge and rapidly evolving, with no dedicated courses available domestically or internationally. If you're interested in gaining a comprehensive overview of machine learning compilation, this course is worth exploring.

The curriculum predominantly centers around the popular machine learning compilation framework [Apache TVM](https://tvm.apache.org/), co-founded by Chen Tianqi. It delves into transforming various machine learning models developed in frameworks like Tensorflow, Pytorch, and Jax into deployment patterns with higher performance and adaptability across different hardware. The course imparts knowledge at a relatively high level, presenting macro-level concepts. Each session is accompanied by a Jupyter Notebook that provides code-based explanations of the concepts. If you are involved in TVM-related programming and development, this course offers rich and standardized code examples for reference.

All course resources are open-source, with versions available in both Chinese and English. The course recordings can be found on both Bilibili and YouTube in both languages.

## Course Resources

- Course Website：<https://mlc.ai/summer22-zh/>
- Course Videos：[Bilibili][Bilibili_link]
- Course Notes：<https://mlc.ai/zh/index.html>
- Course Assignments：<https://github.com/mlc-ai/notebooks/blob/main/assignment>

[Bilibili_link]: https://www.bilibili.com/video/BV15v4y1g7EU?spm_id_from=333.337.search-card.all.click&vd_source=a4d76d1247665a7e7bec15d15fd12349
