# CS224n: Natural Language Processing

## Course Overview

- University：Stanford
- Prerequisites：Fundations of Deep Learning + Python
- Programming Language：Python
- Course Difficulty：🌟🌟🌟🌟
- Estimated Hours：80 hours

CS224n is an introductory course in Natural Language Processing (NLP) offered by Stanford and led by renowned NLP expert Chris Manning, the creator of the word2vec algorithm. The course covers core concepts in the field of NLP, including word embeddings, RNNs, LSTMs, Seq2Seq models, machine translation, attention mechanisms, Transformers, and more.

The course consists of 5 progressively challenging programming assignments covering word vectors, the word2vec algorithm, dependency parsing, machine translation, and fine-tuning a Transformer.

The final project involves training a Question Answering (QA) model on the well-known SQuAD dataset. Some students' final projects have even led to publications in top conferences.

## Course Resources

- Course Website：<http://web.stanford.edu/class/cs224n/index.html>
- Course Videos: Search for 'CS224n' on Bilibili <https://www.bilibili.com/>
- Course Textbook：N/A
- Course Assignments：<http://web.stanford.edu/class/cs224n/index.html>，5 Programming Assignments + 1 Final Project

## Resource Compilation

All resources and assignment implementations used by @PKUFlyingPig during the course are compiled in [PKUFlyingPig/CS224n - GitHub](https://github.com/PKUFlyingPig/CS224n)

