# CS285: Deep Reinforcement Learning

## Course Overview

- University：UC Berkeley
- Prerequisites：CS188, CS189
- Programming Language：Python
- Course Difficulty：🌟🌟🌟🌟
- Estimated Hours：80 hours

The CS285 course, currently taught by Professor Sergey Levine, covers various aspects of deep reinforcement learning. It is suitable for students with a foundational understanding of machine learning, including concepts such as Markov Decision Processes (MDPs). The course involves a substantial amount of mathematical formulas, so a reasonable mathematical background is recommended. Additionally, the professor regularly updates the course content and assignments to reflect the latest research developments, making it a dynamic learning experience.

For course content access, as of the Fall 2022 semester, the teaching format involves pre-recorded videos for students to watch before class. The live sessions mainly focus on Q&A, where the professor discusses selected topics from the videos and answers students' questions. Therefore, the provided course video links already include all the content. The assignments consist of five programming projects, each involving the implementation and comparison of classical models. Occasionally, assignments may also include the reproduction of recent models. The final submission typically includes a report. Given that assignments provide a framework and often involve code completion based on hints, the difficulty level is not excessively high.

In summary, this course is suitable for beginners entering the field of deep reinforcement learning. Although the difficulty increases as the course progresses, it offers a rewarding learning experience.

## Course Resources

- Course Website: <http://rail.eecs.berkeley.edu/deeprlcourse/>
- Course Videos: <https://www.youtube.com/playlist?list=PL_iWQOsE6TfX7MaC6C3HcdOf1g337dlC9>
- Course Texbook: N/A
- Course Assignments: <http://rail.eecs.berkeley.edu/deeprlcourse/>, 5 programming assignments
