# SEEDLabs

## Descriptions

- Offered by: Syracuse University
- Prerequisites: None
- Programming Languages: C, x86 assembly
- Difficulty: 🌟🌟🌟🌟
- Class Hour: 150 Hours

Syracuse University's cybersecurity course, supported by a $1.3 million grant from the NSF, has developed hands-on practical lab exercises known as SEED Labs. This course emphasizes both theoretical instruction and practical hands-on experience, providing detailed open-source lecture materials, video tutorials, textbooks printed in multiple languages, and ready-to-use attack and defense environments based on virtual machines and Docker. Currently, 1,050 research institutions worldwide are using this project.

It covers a wide range of topics in the field of computer and information security, including software security, network security, web security, operating system security, and mobile application security.

## Course Resources

- Course Website: <https://seedsecuritylabs.org/index.html>
- Recordings: <https://www.handsonsecurity.net/video.html>
- Textbooks: <https://www.handsonsecurity.net/index.html>
- Assignments: There are more than 40 labs in this course, the lab environment can be built with customized virtual machines and docker provided by the course in [quickly set up](https://seedsecuritylabs.org/labsetup.html) , and detailed principle explanations and experimental guidance are also provided. Take [Buffer Overflow Experiment](https://seedsecuritylabs.org/Labs_20.04/Software/Buffer_Overflow_Setuid/) as an example. This experiment belongs to [Software Security Topic](https://seedsecuritylabs.org/Labs_20.04/Software /), here is its [Experimental Guide](https://seedsecuritylabs.org/Labs_20.04/Files/Buffer_Overflow_Setuid/Buffer_Overflow_Setuid.pdf), here is its corresponding [Textbook Content](https://www.handsonsecurity .net/files/chapters/buffer_overflow_c.pdf)

## Personal Resources

All resources and assignment implementations used by @LaPhilosophie in learning this course are maintained in [LaPhilosophie/seedlab - GitHub](https://github.com/LaPhilosophie/seedlab). 