# GAMES103

## Course Introduction

- **University**: Style3D / Oregon State University (OSU)
- **Prerequisites**: Linear Algebra, Advanced Mathematics, College Physics, Programming Skills, Basic Graphics Knowledge
- **Programming Language**: C#
- **Course Difficulty**: 🌟🌟🌟🌟
- **Estimated Study Time**: 50 hours

Official Introduction:

> This course serves as an introduction to physics-based computer animation techniques, focusing on various fundamental physical animation simulation technologies.
>
> The course mainly covers four areas: 1) Rigid body simulation; 2) Particle systems, springs, constraints, and cloth simulation; 3) Elastic body simulation based on the finite element method; 4) Fluid simulation.
>
> The course content will not delve into specific physical simulation engines but will discuss the technologies behind various engines and their pros and cons. Since developing and learning physical simulations requires a solid mathematical foundation, the initial stages of the course will also spend some time reviewing necessary mathematical concepts. Upon successful completion of the course, students should have a deep understanding of basic physical simulation techniques and some exposure to advanced simulation technologies.

In graphics, the field can be roughly divided into rendering, simulation, and geometry. While GAMES101 and GAMES202 mainly focus on rendering, GAMES103 is an excellent resource for learning about physical simulation.

## Course Resources

- **Course Website**: [GAMES103](http://games-cn.org/games103/)
- **Course Videos**: [Bilibili](https://www.bilibili.com/video/BV12Q4y1S73g)
- **Reference Materials**: [Course PPT](https://www.aliyundrive.com/s/YGuzfDCzw4n/folder/61824d985307bbf3920044b4afd48abb633441f6)
- **Course Assignments**: Four assignments, available on the official BBS mini-app or the unofficial Repo: [GAMES103 HW](https://github.com/indevn/GAMES103/tree/main/HW)

## Resource Summary

All resources and homework requirements used by @indevn during the course are compiled at [GAMES103 Unofficial](https://github.com/indevn/GAMES103). For detailed implementations of the assignments, there are many articles on Zhihu that provide in-depth explanations and can be referenced.