# GAMES202

## Course Introduction

- **University**: University of California, Santa Barbara (UCSB)
- **Prerequisites**: Linear Algebra, Advanced Mathematics, C++, GAMES101
- **Programming Language**: C++
- **Course Difficulty**: 🌟🌟🌟🌟
- **Estimated Study Time**: 60 hours

Official Introduction:

> This course comprehensively introduces the key issues and solutions in modern real-time rendering. Since real-time rendering (>30 FPS) demands high speed, the focus of this course is on how to break the trade-off between speed and quality under strict time constraints, ensuring both high-speed real-time performance and photorealism.
>
> The course will be presented in a thematic manner, covering cutting-edge content from both academia and industry, including: (1) real-time soft shadow rendering; (2) ambient lighting; (3) global illumination with or without precomputation; (4) physically-based shading models and methods; (5) real-time ray tracing; (6) anti-aliasing and supersampling; as well as various common acceleration methods.
>
> In addition to the latest and most comprehensive content, an important distinction of this course from other real-time rendering tutorials is that it does not teach the use of game engines or emphasize specific shader implementation techniques. Instead, it focuses on the science and knowledge behind real-time rendering. The goal of this course is to provide you with a solid foundation to develop your own real-time rendering engine upon completion.

As an advanced course following GAMES101, GAMES202 offers a slightly increased level of difficulty, but it's manageable for students who have completed GAMES101. Each project requires a moderate amount of coding but involves significant thought.

## Course Resources

- **Course Website**: [GAMES202](https://sites.cs.ucsb.edu/~lingqi/teaching/games202.html)
- **Course Videos**: [Bilibili](https://www.bilibili.com/video/BV1YK4y1T7yY)
- **Course Textbook**: Real-Time Rendering, 4th edition.
- **Course Assignments**: [5 Projects](http://games-cn.org/forums/topic/games202zuoyehuizong/)