# CMU 17-803: Empirical Methods

## 课程简介

- 所属大学：CMU
- 先修要求：面向从事软件工程实证研究的博士生开设，虽然没有硬性先修要求但最好有一定的计算机基础
- 编程语言：不限
- 课程难度：🌟🌟🌟
- 预计学时：100 小时

这门课专注于一个相对“陌生”的领域——包括但不限于软件工程领域的实证研究，由 [Bogdan Vasilescu](https://bvasiles.github.io/) 讲授，他在实证研究和开源软件研究方面非常深入。

这门课是 CMU 为从事该方向研究的博士生开设的，涵盖一系列定性与定量研究方法，如访谈、定性编码、调查设计以及多种数据统计分析方法，帮助学生了解、学习与从事实证研究。课程还会介绍挖掘和整合 GitHub 和 Stack Overflow 等软件存储库中的数据，并运用统计建模、社交网络分析等数据分析技术。

尽管计算机领域在传统上更注重工程技术，但对于工具、技术的设计、评估以及其可能的社会价值来说，实证研究是必需的。例如评估新算法或新技术框架，对某个领域进行相关数据分析，去了解从业者可能面临的挑战。这门课可以扩展和补充专注于技术领域视角。对于想要从事涉及软件工程领域实证研究的科研方向的朋友，这门课可能是一个很好的入门课程。

## 课程资源

- 课程网站：[Spring 2024](https://bvasiles.github.io/empirical-methods/), [Fall 2022](https://bvasiles.github.io/empirical-methods/fall-2022/), [Spring 2021](https://bvasiles.github.io/empirical-methods/spring-2021/), [Fall 2018](https://bvasiles.github.io/empirical-methods/fall-2018/)
- 课程视频：[Spring 2024](https://www.youtube.com/playlist?list=PLuPUOEODcOmsiOxD7LK5EcQcj34Y9NwYg), [Fall 2022](https://www.youtube.com/watch?v=IDtePCle3Qc)
- 课程教材：未公开，每节课前会有阅读材料
- 课程作业：未公开

## 资源汇总

这门课中用到的所有资源都汇总在 [bvasiles/empirical-methods - GitHub](https://github.com/bvasiles/empirical-methods) 中。